// Code generated by protoc-gen-validate. DO NOT EDIT.
// source: internal/module/agent_tracker/agent_tracker.proto

package agent_tracker

import (
	"bytes"
	"errors"
	"fmt"
	"net"
	"net/mail"
	"net/url"
	"regexp"
	"sort"
	"strings"
	"time"
	"unicode/utf8"

	"google.golang.org/protobuf/types/known/anypb"
)

// ensure the imports are used
var (
	_ = bytes.MinRead
	_ = errors.New("")
	_ = fmt.Print
	_ = utf8.UTFMax
	_ = (*regexp.Regexp)(nil)
	_ = (*strings.Reader)(nil)
	_ = net.IPv4len
	_ = time.Duration(0)
	_ = (*url.URL)(nil)
	_ = (*mail.Address)(nil)
	_ = anypb.Any{}
	_ = sort.Sort
)

// Validate checks the field values on ConnectedAgentInfo with the rules
// defined in the proto definition for this message. If any rules are
// violated, the first error encountered is returned, or nil if there are no violations.
func (m *ConnectedAgentInfo) Validate() error {
	return m.validate(false)
}

// ValidateAll checks the field values on ConnectedAgentInfo with the rules
// defined in the proto definition for this message. If any rules are
// violated, the result is a list of violation errors wrapped in
// ConnectedAgentInfoMultiError, or nil if none found.
func (m *ConnectedAgentInfo) ValidateAll() error {
	return m.validate(true)
}

func (m *ConnectedAgentInfo) validate(all bool) error {
	if m == nil {
		return nil
	}

	var errors []error

	if m.GetAgentMeta() == nil {
		err := ConnectedAgentInfoValidationError{
			field:  "AgentMeta",
			reason: "value is required",
		}
		if !all {
			return err
		}
		errors = append(errors, err)
	}

	if all {
		switch v := interface{}(m.GetAgentMeta()).(type) {
		case interface{ ValidateAll() error }:
			if err := v.ValidateAll(); err != nil {
				errors = append(errors, ConnectedAgentInfoValidationError{
					field:  "AgentMeta",
					reason: "embedded message failed validation",
					cause:  err,
				})
			}
		case interface{ Validate() error }:
			if err := v.Validate(); err != nil {
				errors = append(errors, ConnectedAgentInfoValidationError{
					field:  "AgentMeta",
					reason: "embedded message failed validation",
					cause:  err,
				})
			}
		}
	} else if v, ok := interface{}(m.GetAgentMeta()).(interface{ Validate() error }); ok {
		if err := v.Validate(); err != nil {
			return ConnectedAgentInfoValidationError{
				field:  "AgentMeta",
				reason: "embedded message failed validation",
				cause:  err,
			}
		}
	}

	if t := m.GetConnectedAt(); t != nil {
		ts, err := t.AsTime(), t.CheckValid()
		if err != nil {
			err = ConnectedAgentInfoValidationError{
				field:  "ConnectedAt",
				reason: "value is not a valid timestamp",
				cause:  err,
			}
			if !all {
				return err
			}
			errors = append(errors, err)
		} else {

			gt := time.Unix(0, 0)

			if ts.Sub(gt) <= 0 {
				err := ConnectedAgentInfoValidationError{
					field:  "ConnectedAt",
					reason: "value must be greater than 1970-01-01 00:00:00 +0000 UTC",
				}
				if !all {
					return err
				}
				errors = append(errors, err)
			}

		}
	}

	// no validation rules for ConnectionId

	// no validation rules for AgentId

	// no validation rules for ProjectId

	if len(errors) > 0 {
		return ConnectedAgentInfoMultiError(errors)
	}

	return nil
}

// ConnectedAgentInfoMultiError is an error wrapping multiple validation errors
// returned by ConnectedAgentInfo.ValidateAll() if the designated constraints
// aren't met.
type ConnectedAgentInfoMultiError []error

// Error returns a concatenation of all the error messages it wraps.
func (m ConnectedAgentInfoMultiError) Error() string {
	var msgs []string
	for _, err := range m {
		msgs = append(msgs, err.Error())
	}
	return strings.Join(msgs, "; ")
}

// AllErrors returns a list of validation violation errors.
func (m ConnectedAgentInfoMultiError) AllErrors() []error { return m }

// ConnectedAgentInfoValidationError is the validation error returned by
// ConnectedAgentInfo.Validate if the designated constraints aren't met.
type ConnectedAgentInfoValidationError struct {
	field  string
	reason string
	cause  error
	key    bool
}

// Field function returns field value.
func (e ConnectedAgentInfoValidationError) Field() string { return e.field }

// Reason function returns reason value.
func (e ConnectedAgentInfoValidationError) Reason() string { return e.reason }

// Cause function returns cause value.
func (e ConnectedAgentInfoValidationError) Cause() error { return e.cause }

// Key function returns key value.
func (e ConnectedAgentInfoValidationError) Key() bool { return e.key }

// ErrorName returns error name.
func (e ConnectedAgentInfoValidationError) ErrorName() string {
	return "ConnectedAgentInfoValidationError"
}

// Error satisfies the builtin error interface
func (e ConnectedAgentInfoValidationError) Error() string {
	cause := ""
	if e.cause != nil {
		cause = fmt.Sprintf(" | caused by: %v", e.cause)
	}

	key := ""
	if e.key {
		key = "key for "
	}

	return fmt.Sprintf(
		"invalid %sConnectedAgentInfo.%s: %s%s",
		key,
		e.field,
		e.reason,
		cause)
}

var _ error = ConnectedAgentInfoValidationError{}

var _ interface {
	Field() string
	Reason() string
	Key() bool
	Cause() error
	ErrorName() string
} = ConnectedAgentInfoValidationError{}

// Validate checks the field values on DisconnectAgentInfo with the rules
// defined in the proto definition for this message. If any rules are
// violated, the first error encountered is returned, or nil if there are no violations.
func (m *DisconnectAgentInfo) Validate() error {
	return m.validate(false)
}

// ValidateAll checks the field values on DisconnectAgentInfo with the rules
// defined in the proto definition for this message. If any rules are
// violated, the result is a list of violation errors wrapped in
// DisconnectAgentInfoMultiError, or nil if none found.
func (m *DisconnectAgentInfo) ValidateAll() error {
	return m.validate(true)
}

func (m *DisconnectAgentInfo) validate(all bool) error {
	if m == nil {
		return nil
	}

	var errors []error

	if all {
		switch v := interface{}(m.GetAgentMeta()).(type) {
		case interface{ ValidateAll() error }:
			if err := v.ValidateAll(); err != nil {
				errors = append(errors, DisconnectAgentInfoValidationError{
					field:  "AgentMeta",
					reason: "embedded message failed validation",
					cause:  err,
				})
			}
		case interface{ Validate() error }:
			if err := v.Validate(); err != nil {
				errors = append(errors, DisconnectAgentInfoValidationError{
					field:  "AgentMeta",
					reason: "embedded message failed validation",
					cause:  err,
				})
			}
		}
	} else if v, ok := interface{}(m.GetAgentMeta()).(interface{ Validate() error }); ok {
		if err := v.Validate(); err != nil {
			return DisconnectAgentInfoValidationError{
				field:  "AgentMeta",
				reason: "embedded message failed validation",
				cause:  err,
			}
		}
	}

	// no validation rules for ConnectionId

	// no validation rules for AgentId

	// no validation rules for ProjectId

	if len(errors) > 0 {
		return DisconnectAgentInfoMultiError(errors)
	}

	return nil
}

// DisconnectAgentInfoMultiError is an error wrapping multiple validation
// errors returned by DisconnectAgentInfo.ValidateAll() if the designated
// constraints aren't met.
type DisconnectAgentInfoMultiError []error

// Error returns a concatenation of all the error messages it wraps.
func (m DisconnectAgentInfoMultiError) Error() string {
	var msgs []string
	for _, err := range m {
		msgs = append(msgs, err.Error())
	}
	return strings.Join(msgs, "; ")
}

// AllErrors returns a list of validation violation errors.
func (m DisconnectAgentInfoMultiError) AllErrors() []error { return m }

// DisconnectAgentInfoValidationError is the validation error returned by
// DisconnectAgentInfo.Validate if the designated constraints aren't met.
type DisconnectAgentInfoValidationError struct {
	field  string
	reason string
	cause  error
	key    bool
}

// Field function returns field value.
func (e DisconnectAgentInfoValidationError) Field() string { return e.field }

// Reason function returns reason value.
func (e DisconnectAgentInfoValidationError) Reason() string { return e.reason }

// Cause function returns cause value.
func (e DisconnectAgentInfoValidationError) Cause() error { return e.cause }

// Key function returns key value.
func (e DisconnectAgentInfoValidationError) Key() bool { return e.key }

// ErrorName returns error name.
func (e DisconnectAgentInfoValidationError) ErrorName() string {
	return "DisconnectAgentInfoValidationError"
}

// Error satisfies the builtin error interface
func (e DisconnectAgentInfoValidationError) Error() string {
	cause := ""
	if e.cause != nil {
		cause = fmt.Sprintf(" | caused by: %v", e.cause)
	}

	key := ""
	if e.key {
		key = "key for "
	}

	return fmt.Sprintf(
		"invalid %sDisconnectAgentInfo.%s: %s%s",
		key,
		e.field,
		e.reason,
		cause)
}

var _ error = DisconnectAgentInfoValidationError{}

var _ interface {
	Field() string
	Reason() string
	Key() bool
	Cause() error
	ErrorName() string
} = DisconnectAgentInfoValidationError{}

// Validate checks the field values on AgentPodInfo with the rules defined in
// the proto definition for this message. If any rules are violated, the first
// error encountered is returned, or nil if there are no violations.
func (m *AgentPodInfo) Validate() error {
	return m.validate(false)
}

// ValidateAll checks the field values on AgentPodInfo with the rules defined
// in the proto definition for this message. If any rules are violated, the
// result is a list of violation errors wrapped in AgentPodInfoMultiError, or
// nil if none found.
func (m *AgentPodInfo) ValidateAll() error {
	return m.validate(true)
}

func (m *AgentPodInfo) validate(all bool) error {
	if m == nil {
		return nil
	}

	var errors []error

	// no validation rules for AgentId

	// no validation rules for PodId

	if len(errors) > 0 {
		return AgentPodInfoMultiError(errors)
	}

	return nil
}

// AgentPodInfoMultiError is an error wrapping multiple validation errors
// returned by AgentPodInfo.ValidateAll() if the designated constraints aren't met.
type AgentPodInfoMultiError []error

// Error returns a concatenation of all the error messages it wraps.
func (m AgentPodInfoMultiError) Error() string {
	var msgs []string
	for _, err := range m {
		msgs = append(msgs, err.Error())
	}
	return strings.Join(msgs, "; ")
}

// AllErrors returns a list of validation violation errors.
func (m AgentPodInfoMultiError) AllErrors() []error { return m }

// AgentPodInfoValidationError is the validation error returned by
// AgentPodInfo.Validate if the designated constraints aren't met.
type AgentPodInfoValidationError struct {
	field  string
	reason string
	cause  error
	key    bool
}

// Field function returns field value.
func (e AgentPodInfoValidationError) Field() string { return e.field }

// Reason function returns reason value.
func (e AgentPodInfoValidationError) Reason() string { return e.reason }

// Cause function returns cause value.
func (e AgentPodInfoValidationError) Cause() error { return e.cause }

// Key function returns key value.
func (e AgentPodInfoValidationError) Key() bool { return e.key }

// ErrorName returns error name.
func (e AgentPodInfoValidationError) ErrorName() string { return "AgentPodInfoValidationError" }

// Error satisfies the builtin error interface
func (e AgentPodInfoValidationError) Error() string {
	cause := ""
	if e.cause != nil {
		cause = fmt.Sprintf(" | caused by: %v", e.cause)
	}

	key := ""
	if e.key {
		key = "key for "
	}

	return fmt.Sprintf(
		"invalid %sAgentPodInfo.%s: %s%s",
		key,
		e.field,
		e.reason,
		cause)
}

var _ error = AgentPodInfoValidationError{}

var _ interface {
	Field() string
	Reason() string
	Key() bool
	Cause() error
	ErrorName() string
} = AgentPodInfoValidationError{}
